<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2013 IMIA net based solutions (d.frerich@imia.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

namespace IMIA\ImiaPageteaser\Domain\Model;

use TYPO3\CMS\Extbase\Persistence\ObjectStorage;
use IMIA\BaseExt\Annotation\SQL;
use IMIA\BaseExt\Annotation\TCA;

/**
 * @package     imia_pageteaser
 * @subpackage  Domain\Model
 * @author      David Frerich <d.frerich@imia.de>
 * )
 */
abstract class AbstractPageAlt extends \IMIA\BaseExt\Domain\Model\PageLanguageOverlay
{
    /**
     * @var \TYPO3\CMS\Core\Resource\FileRepository
     * @inject
     * @FIXME How to do this a better way?
     */
    protected $fileRepository;

    /**
     * @var string
     */
    protected $teaserImage;

    /**
     * @return \IMIA\ImiaPageteaser\Domain\Model\FileReference
     * @FIXME How to do this a better way?
     */
    public function getTeaserImage()
    {
        if (!$this->teaserImage || !is_object($this->teaserImage)) {
            $files = $this->fileRepository->findByRelation('pages_language_overlay', 'teaser_image', $this->uid);

            if (count($files) > 0) {
                $this->teaserImage = array_shift($files);
            } elseif (!$this->teaserImage && $this->getPage() && is_object($this->getPage())) {
                $this->teaserImage = $this->getPage()->getTeaserImage();
            } else {
                $this->teaserImage = null;
            }
        }

        return $this->teaserImage;
    }

    /**
     * @return integer
     * @FIXME Very dirty, but is there a better way?
     */
    public function getContentFileRelations()
    {
        if ($this->getPage() && is_object($this->getPage())) {
            return $this->getPage()->getContentFileRelations();
        } else {
            return null;
        }
    }

    /**
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\IMIA\ImiaPageteaser\Domain\Model\Category>
     */
    public function getCategories()
    {
        if ($this->getPage() && is_object($this->getPage())) {
            return $this->getPage()->getCategories();
        } else {
            return null;
        }
    }

    /**
     * @return \IMIA\ImiaPageteaser\Domain\Model\Category
     */
    public function getCategory()
    {
        if ($this->getPage() && is_object($this->getPage())) {
            return $this->getPage()->getCategory();
        } else {
            return null;
        }
    }

    /*
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\IMIA\ImiaPageteaser\Domain\Model\Page>
     */
    public function getTeaserPages()
    {
        if ($this->getPage() && is_object($this->getPage())) {
            return $this->getPage()->getTeaserPages();
        } else {
            return null;
        }
    }
}